'use strict';

//继承

var util = require('util');
function Base() {
    this.name = 'base';
    this.base = 1991;
    this.sayHello = function () {
        console.log('Hello ' + this.name);
    };
}
Base.prototype.showName = function () {
    console.log(this.name);
};
function Sub() {
    this.name = 'sub';
}
util.inherits(Sub, Base);
var objBase = new Base();
objBase.showName();
objBase.sayHello();
console.log(objBase);
var objSub = new Sub();
objSub.showName();
//objSub.sayHello();
console.log(objSub);

/**
 * Sub 继承了Base
 * 我们定义了一个基础对象Base 和一个继承自Base 的Sub，
 * Base 有三个在构造函数 内定义的属性和一个原型中定义的函数，
 * 通过util.inherits 实现继承
 * Sub 仅仅继承了Base 在原型中定义的函数，
 * 而构造函数内部创造的 base 属 性和 sayHello 函数都没有被 Sub 继承。
 * 同时，在原型中定义的属性不会被console.log 作 为对象的属性输出
 */